unit OSData ;
{  묨}
interface
const
  KeyEsc=#27;
  KeyPlus='+';
  KeyMinus='-';
  KeyF1=#59;
  SpeedchangeStep:real=0.05;{%}
  MaxSpeed:real=1000;{ᨬ쭠 ᪮}
  MinSpeed:real=0.1; {쭠 ᪮}
  NumberOfCommands=2;
  MAX_PROCESS=15;
  { 樨 ﭨ ᮢ}
  S_processCondition:array[0..8] of String=(
  '',
  '',
  '',
  '',
  '. I/O',
  ' I/O',
  '..',
  '. IO',
  '.');
  S_CPUCondition:array[0..1] of string=(
  '',
  ''
  );
  S_CodOperation:array[0..2] of string=(
  '.',
  'I/O     ',
  '. '
  );

Type
  TProcessCondition=(NONE,READY,ACTIVE,LOAD,InitializingIO,FinishingIO,
     BlockedOnAM,BlockedOnIO,PAUSED);
  TCPUCondition=(WORK,WAITING);
  TypeCommand=(COMMAND_ARITHMETICAL,COMMAND_IO,COMMAND_EXIT);
  TypeCodOp=(CODOP_ARITHMETICAL, CODOP_IO,CODOP_EXIT);
  TypeOperand=integer;{}
  TypeAdress=integer;{⥬᪨ }
  TProcess=record
  {室 ࠬ :}
   Task_ID,         {䨪  (: 1, 2, 3) }
   V_task,          {ࠧ }
   N_cmnd,          { ⥫쭮-+ 믮 
                    (᫮  ( ⠪⮢!) )}
   D_inOut,         {⢮   (뢮)  業⭮
                     ⭮襭  饬   }
   N_InOut,         {⥫쭮   (뢮)  ⭮襭
                     ᫨⥫ }
   {Prior:integer;   {ਮ }
   {室 ࠬ :}
   Process:integer;     { }
   Condition:TProcessCondition;  {ﭨ }
   PC_IO,               {稪 ⠪⮢   뢮}
   T_mono,              {६ 믮  ணࠬ }
   T_multi,             {६ 믮    }
   D_exe,               {業 㢥祭 ६ 믮
                            ࠢ  ணࠬ }
   D_ready,             {६ 宦  ᯨ᪥ ⮢
                         (⮩ )  業  ६
                         믮 }
   Prior:integer;       {⥪騩 ਮ (  訬
                         ਮ⮬ 믮 ॥)}
   Cmnd:integer;          {稪 }
   {⥫ ࠬ :}
   T_Loaded:integer;     {⢮ ⠪⮢,  த 
                           㦠}
   IOCmndProcess:integer; {⢮ ⠪⮢,  믮
                          ⥪ }
  end;






{ ६}
var
   Quit:boolean;
   CountTiks:longint absolute $0040:$006C;
   LastCountTiks:longint;
   TaktBeforeDelay:integer;{६  믮 প}

{室 ࠬ :}
   OZUSize,           {  }
   OZUFreeSize,       {ࠧ ᢮  }
   Kvant,           { ६ (᫮ ⠪⮢ ஢, 㯭
                      ﭨ "⨢")}
   T_next,          {   롮   믮 
                     (⠪⮢ 㥬 ६)}
   TInitIO,         {    ﭨ   饭
                      (뢮) ( ᫥ ⠪⮢)}
   TIntrIO,         {    㦨 ᨣ 砭
                    (뢠)  (뢮) ( ᫥ ⠪⮢)}
   T_Load:integer;  {᫮ ⠪⮢  㧪  }
   Speed:real;      { ࠡ  ⠪⮢  1 ᥪ㭤}

   T_Globl:integer; {   饭  騬 묨 (
                    ⨯୮ )}
   CurKvant:integer; {- ⠪⮢,  ⥪騩  - 
                     ﭨ ⮢.}


{室 ࠬ 業ࠫ쭮 }
   PC:word ;{稪 }
   CurProc:integer;               { 믮塞  }
   Command: TCPUCondition;      {믮塞   }
   CodOperation:TypeCodOp;
   Operand1,Operand2:TypeOperand;
{室 ࠬ :}
   Cmnd:integer;        {稪 }
   N_Procc,             {᫮ 㦥 }
   D_sys,               {⥬   ( 業)}
   T_multi,             {६ ࠡ     ᪠}
   M_multi,             {᫮ 믮    砫
                         ஢}
   T_mono,              {६ 믮 M_multi  
                         ணࠬ ⥬}
   M_mono,              {᫮ ,     믮
                         ६ T_multi  ணࠬ  }
   D_multi:integer;     {ந⥫쭮    ࠢ
                         ணࠬ   業}
   {ᨢ ᮢ}
   Process:array [0..MAX_PROCESS] of TProcess;
   ProcessDefault:TProcess;
   NextTask_ID:integer;

   {न  뢮:}
   ProcessesBoxX,ProcessesBoxY:integer;{न  ᮢ}
   SettingsboxX,SettingsBoxY:integer;  {न  ஥ ᪮...}
   CPUBoxX,CPUBoxY:integer;            {न  }
   SystemBoxX,SystemBoxY:integer;      {न  ⥬}
   ControlBoxX,ControlBoxY:integer;
implementation

end.