unit OSProc;
{ ࠡ⪨ ᮢ}
interface
  uses OSData;
  {㭪 ࠡ⪨ 1 ⠪}
  Function ProcessTakt:boolean;
  {㭪 樨 }
  Function GenerateProcess:boolean;
  {㭪 樨 ᮢ ᯮ GenerateProcess}
  Function GenerateProcesses:boolean;
  Function LoadProcesses:boolean;
implementation
uses OSSVTime,OSCPU,OSIOCPU;  {ᯮ 㯥ࢨ ६}

function CheckOZU(Size:integer):boolean;
var yes:boolean;
begin
  if (OZUFreeSize<Size) then yes:=FALSE
  else yes:=TRUE;
  CheckOZU:=yes;
end;

Function GenerateProcess:boolean;
var n:integer;
begin
  n:=0;
  while (n<MAX_PROCESS) and (Process[n].Condition<>NONE) do inc(n);
  if (CheckOZU(ProcessDefault.V_Task)=TRUE) then
  begin
    Process[n]:=ProcessDefault;
    Dec(OZUFreeSize,process[n].V_Task);
    Process[n].Task_ID:=NextTask_ID;
    inc(NextTask_ID);
  end;
end;

Function GenerateProcesses:boolean;
var n:integer;
begin
  for n:=0 to MAX_PROCESS do
  begin
     GenerateProcess;
  end;
end;

Function MyDelay:boolean;
var yes:boolean;
begin
  yes:=TRUE;
  if (Speed>=18) then
  begin
    if (TaktBeforeDelay=0) then
    begin
      if (((Counttiks-LastCountTiks) )<1) then yes:=FALSE
      else
      begin
        LastCountTiks:=CountTiks;
        TaktBeforeDelay:=Round(Speed /18);
      end;
    end
  end
  else
  begin
    if (((Counttiks-LastCountTiks) )<Round(18/Speed) ) then yes:=FALSE
    else    LastCountTiks:=CountTiks;
  end;
  MyDelay:=yes;
end;

Function ProcessTakt:boolean;
begin
  if (MyDelay) then
  begin
    DoTakt;
    ProcessIOCPU;
    Dec(TaktBeforeDelay);
    if ((CurKvant=0) or(CurProc=-1)) then ChangeProcess;
  end;
end;

Function LoadProcess(n:integer):boolean;
begin
   Inc(Process[n].T_Loaded);
   {᫨  㧨,  ⠢  ﭨ }
   if (Process[n].T_Loaded=T_Load) then Process[n].Condition:=READY;

end;

Function LoadProcesses:boolean;
var n:integer;
begin
  for n:=0 to MAX_PROCESS do
  begin
    if (Process[n].Condition=LOAD) then LoadProcess(n);
  end;
end;

end.