unit OSPrint;
{  뢮  ࠭}
interface
uses OSData;
  {뢮 ᥣ  ࠭}
  Function PrintAll:boolean;
  Procedure ShowHelp;
implementation
uses Crt;

Function PrintProcesses:boolean;
var n:integer;
begin
  gotoxy(ProcessesBoxX,ProcessesBoxY);
  write('. .    . - .  IO  . IO IO');
  for n:=0 to MAX_PROCESS do
  begin
    GotoXY(ProcessesBoxX,ProcessesBoxY+n+1);
    write(n:5,
      Process[n].Task_ID:6,
      Process[n].Cmnd:6,'/',  Process[n].N_cmnd:5,
      Process[n].V_Task:6,
      Process[n].D_InOut:6,'%',
      S_ProcessCondition[integer(Process[n].Condition)]:9,
      Process[n].PC_IO:5,
      (Process[n].N_InOut-Process[n].IOCmndProcess):3
      );
  end;
end;

Function PrintSettings:boolean;
begin
  gotoxy(SettingsBoxX,SettingsBoxY);
  Write('-: ',Speed:4:3); Writeln('  ');
  gotoxy(SettingsBoxX,SettingsBoxY+1);
  write('. . -: ',T_Load);
end;

Function PrintCPU:boolean;
begin
  gotoxy(CPUBoxX,CPUBoxY);
  Write(': ',PC:5);
  gotoxy(CPUBoxX,CPUBoxY+1);
  Write('. ',S_CPUCondition[integer(Command)]);
  gotoxy(CPUBoxX,CPUBoxY+3);
  write(' -:',S_CodOperation[integer(CodOperation)] );
  gotoxy(CPUBoxX,CPUBoxY+4);
  write('.:');if (CurProc>=0) then write(Process[CurProc].Task_ID:5) else write('     ' );
end;

Function PrintSystem:boolean;
begin
  gotoxy(SystemBoxX,SystemBoxY);
  Write(': ',Cmnd:5);
  gotoxy(SystemBoxX,SystemBoxY+1);
  Write('. .: ',OZUFreeSize:5,'/',OZUSize:5);

end;

Procedure PrintControl(ControlBoxX:integer;ControlBoxY:integer);
begin
   gotoxy(ControlBoxX,ControlBoxY);
   writeln('"-"-- ᪮.');
   gotoxy(ControlBoxX,ControlBoxY+1);
   writeln('"+"-- ᪮.');
   gotoxy(ControlBoxX,ControlBoxY+2);
   write('"N"-. -');
   gotoxy(ControlBoxX,ControlBoxY+3);
   write('"P"-');
   gotoxy(ControlBoxX,ControlBoxY+4);
   write('"Esc"-室');
end;

Function PrintAll:boolean;
begin
 GotoXY(1,1);
 PrintCPU;
 PrintSettings;
 PrintProcesses;
 PrintSystem;
 PrintControl(ControlBoxX,ControlBoxY);
 gotoxy(1,25);
 write('  ᮧ ࢠ ஬ ᫠祬  2006 .');
end;

Procedure ShowHelp;
begin
   clrscr;
   writeln('ࠢ. ');
   writeln('ࠢ:');
   PrintControl(1,3);
   writeln('"N"-  ');
   writeln('ࠬ   ப:');
   writeln('"/?- ࠢ"');
   writeln('    த...');
   ReadKey;
   clrscr;

end;


end.